from datetime import datetime
from typing import List, Optional, Dict, Any

from janis_core import *
from janis_core.types.common_data_types import Int, File

Hg_Color_V0_1_0 = CommandToolBuilder(tool="HG_CoLoR", base_command=["HG-CoLoR"], inputs=[ToolInput(tag="in_min_order", input_type=Int(optional=True), prefix="--minorder", doc=InputDocumentation(doc=":        Minimum k-mer size of the variable-order de Bruijn graph (default: K/2).")), ToolInput(tag="in_solid", input_type=Int(optional=True), prefix="--solid", doc=InputDocumentation(doc=":           Minimum number of occurrences to consider a short read k-mer as solid, after correction (default: 1).\nThis parameter should be carefully raised accordingly to the short reads coverage and accuracy,\nand to the chosen maximum order of the graph.\nIt should only be increased when using high coverage of short reads, or a small maximum order.")), ToolInput(tag="in_seeds_overlap", input_type=Int(optional=True), prefix="--seedsoverlap", doc=InputDocumentation(doc=":    Minimum overlap length to allow the merging of two overlapping seeds (default: K - 1).")), ToolInput(tag="in_seeds_distance", input_type=Int(optional=True), prefix="--seedsdistance", doc=InputDocumentation(doc=":   Maximum distance to consider two consecutive seeds for merging (default: 10).")), ToolInput(tag="in_branches", input_type=Int(optional=True), prefix="--branches", doc=InputDocumentation(doc=":        Maximum number of branches exploration (default: 1,250).\nRaising this parameter will result in less split corrected long reads.\nHowever, it will also increase the runtime, and may create chimeric linkings between the seeds.")), ToolInput(tag="in_seed_skips", input_type=Int(optional=True), prefix="--seedskips", doc=InputDocumentation(doc=":       Maximum number of seed skips (default: 3).")), ToolInput(tag="in_mismatches", input_type=Int(optional=True), prefix="--mismatches", doc=InputDocumentation(doc=":      Allowed mismatches when attempting to link two seeds together (default: 3).")), ToolInput(tag="in_best_n", input_type=Int(optional=True), prefix="--bestn", doc=InputDocumentation(doc=":           Top alignments to be reported by BLASR (default: 50).\nThis parameter should be raised accordingly to the short reads coverage.\nIts default value is adapted for a 50x coverage of short reads.\nIt should be decreased with higher coverage, and increased with lower coverage.")), ToolInput(tag="in_nproc", input_type=Int(optional=True), prefix="--nproc", doc=InputDocumentation(doc=":           Number of processes to run in parallel (default: number of cores).")), ToolInput(tag="in_tmpdir", input_type=File(optional=True), prefix="--tmpdir", doc=InputDocumentation(doc=":    Path where to store the directory containing temporary files (default: working directory).")), ToolInput(tag="in_kmc_mem", input_type=Int(optional=True), prefix="--kmcmem", doc=InputDocumentation(doc=":          Maximum amount of RAM for KMC, in GB (default: 12)."))], outputs=[], container=None, version="v0.1.0")


if __name__ == "__main__":
    # or "cwl"
    Hg_Color_V0_1_0().translate("wdl", allow_empty_container=True)

